#include <stdio.h>
#include <malloc.h>
#include <windows.h>
#include <conio.h>

int LoadFileAtAddress(char* filename, unsigned int address, unsigned int padding){

	DWORD l;
	OFSTRUCT o;

	HANDLE h =  (HANDLE)OpenFile(filename, &o , OF_READ);
	
	if(h == INVALID_HANDLE_VALUE ){
		printf("Could not open file %s\n", filename);
		return 0;
	}

	int bufsz = GetFileSize(h,NULL);
	
	if( bufsz == INVALID_FILE_SIZE){
		printf("Could not get filesize\n");
		CloseHandle(h);
		return 0;
	}

	printf("Allocation Base: %x  Size: %x  Padding: %x  End: %x\n", address,bufsz, padding, address+bufsz+padding);
	bufsz += padding;

	printf("Trying to clear way for alloc...\n");
	int x = address;
	while(x < address+bufsz+padding){
		UnmapViewOfFile( (void*)x );
		FreeLibrary( (HMODULE)x );
		x += 0x1000;
	}

	void* mem = VirtualAlloc((void*)address,bufsz, MEM_RESERVE | MEM_COMMIT, PAGE_EXECUTE_READWRITE);

	if((int)mem!=address){
		printf("Could not obtain desired base address...");
		CloseHandle(h);
		return 0;
	}

	ReadFile(h, mem, bufsz ,&l,0);
	CloseHandle(h);
	return (int)mem;
}

void main(){

   int dllBase;
   char *test = "test";	
   char buf[33];

   int fx_rva = 0x21f0;
   void (*MD5_String)(char*,char*);
   
   UnmapViewOfFile((HANDLE)0x400000); //ctype.nls mapped in at 400000

   dllBase = (int)LoadFileAtAddress("md5.dll", 0x400000, 0x1000);

   if(dllBase<1){
		printf("LoadFileAtAddress Failed");
		return;
   }

   printf("DllBase = 0x%x\n", dllBase);

   _asm{
		 mov eax, dllBase
		 add eax, fx_rva
		 mov MD5_String, eax  
   }
   	
   //DebugBreak();
   MD5_String(test,buf);
   printf("MD5(test) = %s\n\n",buf);
   printf("Press any key to continue");
   getch();


}
